spandsp: echo.h File Reference

spandsp 0.0.6

Typedefs | Enumerations | Functions
echo.h File Reference
`#include "fir.h"`

Go to the source code of this file.

## Typedefs
typedef struct echo_can_state_s | echo_can_state_t

## Enumerations
enum | { ECHO_CAN_USE_ADAPTION = 0x01 , ECHO_CAN_USE_NLP = 0x02 , ECHO_CAN_USE_CNG = 0x04 , ECHO_CAN_USE_CLIP = 0x08 , ECHO_CAN_USE_SUPPRESSOR = 0x10 , ECHO_CAN_USE_TX_HPF = 0x20 , ECHO_CAN_USE_RX_HPF = 0x40 , ECHO_CAN_DISABLE = 0x80 }

## Functions
echo_can_state_t * | echo_can_init (int len, int adaption_mode)
int | echo_can_release (echo_can_state_t *ec)
int | echo_can_free (echo_can_state_t *ec)
void | echo_can_flush (echo_can_state_t *ec)
void | echo_can_adaption_mode (echo_can_state_t *ec, int adaption_mode)
int16_t | echo_can_update (echo_can_state_t *ec, int16_t tx, int16_t rx)
int16_t | echo_can_hpf_tx (echo_can_state_t *ec, int16_t tx)
void | echo_can_snapshot (echo_can_state_t *ec)

## Typedef Documentation

## ◆ echo_can_state_t

typedef struct echo_can_state_s echo_can_state_t

G.168 echo canceller descriptor. This defines the working state for a line echo canceller.

## Function Documentation

## ◆ echo_can_adaption_mode()

void echo_can_adaption_mode | ( | echo_can_state_t * | ec,
|  | int | adaption_mode
| ) |  |

Set the adaption mode of a voice echo canceller context.

Parameters

  ec | The echo canceller context.
  adaption_mode | The mode.

Referenced by echo_can_init().

## ◆ echo_can_flush()

void echo_can_flush | ( | echo_can_state_t * | ec | ) |

Flush (reinitialise) a voice echo canceller context.

Parameters

  ec | The echo canceller context.

References echo_can_state_s::fir_taps16, and echo_can_state_s::fir_taps32.

## ◆ echo_can_free()

int echo_can_free | ( | echo_can_state_t * | ec | ) |

Free a voice echo canceller context.

Parameters

  ec | The echo canceller context.

Returns
  0 for OK, else -1.

References echo_can_state_s::fir_taps16, and echo_can_state_s::fir_taps32.

## ◆ echo_can_hpf_tx()

int16_t echo_can_hpf_tx | ( | echo_can_state_t * | ec,
|  | int16_t | tx
| ) |  |

Process to high pass filter the tx signal.

Parameters

  ec | The echo canceller context.
  tx | The transmitted auio sample.

Returns
  The HP filtered transmit sample, send this to your D/A.

## ◆ echo_can_init()

echo_can_state_t * echo_can_init | ( | int | len,
|  | int | adaption_mode
| ) |  |

Create a voice echo canceller context.

Parameters

  len | The length of the canceller, in samples.

Returns
  The new canceller context, or NULL if the canceller could not be created.

References echo_can_adaption_mode(), echo_can_state_s::fir_taps16, and echo_can_state_s::fir_taps32.

## ◆ echo_can_release()

int echo_can_release | ( | echo_can_state_t * | ec | ) |

Release a voice echo canceller context.

Parameters

  ec | The echo canceller context.

Returns
  0 for OK, else -1.

## ◆ echo_can_update()

int16_t echo_can_update | ( | echo_can_state_t * | ec,
|  | int16_t | tx,
|  | int16_t | rx
| ) |  |

Process a sample through a voice echo canceller.

Parameters

  ec | The echo canceller context.
  tx | The transmitted audio sample.
  rx | The received audio sample.

Returns
  The clean (echo cancelled) received sample.

References echo_can_state_s::fir_taps16, and echo_can_state_s::fir_taps32.